
/**
 * Creates and manages an array of objects of type MazeResult.
 * 
 * @author Tina Comston
 * @version Winter 2018
 */
public class Competition
{
    // public constants
    
   /**
    * Constant containing value for MALE.
    */
    public static final int MALE = 1;
    
   /**
    * Constant containing value for FEMALE.
    */
    public static final int FEMALE = 2;
    
   /**
    * Constant containing value for VACCINATED.
    */
    public static final int VACCINATED = 3;
    
   /**
    * Constant containing value for NOT_VACCINATED.
    */
    public static final int NOT_VACCINATED = 4;
    
   /**
    * Constant containing value for ALL.
    */
    public static final int ALL = 5;

    // private constants
    
   /**
    * Constant containing value for maximum size of array.
    */
    private static final int MAX_COUNT = 100;
    
    // instance variables
    
    // Competition description
    private String desc;
    // array companion variable
    private int nextPos;
    // array declaration
    private MazeResult [] results;

    /**
     * Constructor for objects of class Competition.
     *
     * @param  inDesc The competition description.
     */
    public Competition(String inDesc)
    {
        // initialize the instance fields, either setting
        // equal to an explicit parameter or default value
        // as appropriate
        // initialize the array
        
        // your code here
    }

    /**
     * set the competition description.
     * 
     * @param  inDesc The competition description.
     *  
     */
    public void setDesc(String inDesc)
    {
       // your code here
    }
    
    /**
     * get the competition description.
     * 
     * @return String The competition description.
     *  
     */
    public String getDesc()
    {
        // your code here
        // replace the following line with your code
        return null;
    }    
    
    /**
     * get the count of populated elements in the array.
     * 
     * @return int The count of populated elements; also indicates
     *          the next available element position.
     *  
     */
    public int getCount()
    {
        // revise this statement
        return -9;
    }        
    
    /**
     * add a MazeResult object to the array.
     * 
     * @param  inMazeResult The MazeResult object.
     *  
     */
    public void addMazeResult(MazeResult inMazeResult)
    {
        // test array to be less than capacity prior to add
        if (this.nextPos < MAX_COUNT)
        {   
            // set the next available array element to the passed-in reference
            // post increment the array companion variable
            results[this.nextPos++] = inMazeResult;
        }
    }    
    
    /**
     * get a MazeResult object from the array.
     * 
     * @param  inIndex The array index position of the requested object.
     * @return MazeResult The MazeResult object from the array, returns 
     *          null if index not found or invalid.
     *  
     */
    public MazeResult getMazeResult(int inIndex)
    {
        // your code here
        // test the index value to be valid
        
        
            // the index value is valid
            
            // return the object reference at the specified index position
            
        
        
        // a match was not found, return null
        return null;
    }        
    
    /**
     * get a MazeResult object from the array.
     * 
     * @param  inRFID The Rats RFID in the requested object.
     * @return MazeResult The MazeResult object from the array, if not found
     *          returns null.
     *  
     */
    public MazeResult getMazeResult(String inRFID)
    {
        // loop through the array from beginning to end of populated elements
        for (int i = 0; i < this.nextPos; ++i)
        {
            // check the rat object to determine if the chipID matches
            // the given value
            if (this.results[i].getRat().getRFID().equals(inRFID))
            {
                // a match is found
            
                // return the object reference at the loop counter position
                return this.results[i];
            }
        }
        
        // a match was not found, return null
        return null;
    }  
    
    /**
     * get the count of rats for a given category.
     * 
     * @param  inCategory Numeric value representing a rat category.
     * @return int The count of rats.
     *  
     */
    public int getRatCount(int inCategory)
    {
        // set the initial count to 0
        int count = 0;
        Rat tmpRat = null;

        // loop through the array from beginning to end of populated elements
        for (int i = 0; i < this.nextPos; ++i)
        {
            // Initialize a local rat object variable for each iteration
            tmpRat = this.results[i].getRat();
            
            if (this.isCategoryMatch(inCategory, tmpRat))
            {
                // a match was found, increment the count
                count++;
            }
        }
        
        // return the count
        return count;
    } 
    
    /**
     * get the average ACTUAL time of rats for a given category.
     *
     * @param  inCategory Numeric value representing a race category.
     * @return double The average time in maze in seconds.
     *  
     */
    public double getRatAveTime(int inCategory)
    {
        // local variables
        Time tmpTime;
        double tmpSeconds;
        MazeResult tmpResult;
        Rat tmpRat = null;
        double timeInSeconds = 0.0;
        
        // set the initial count to 0
        int count = 0;  
        
        // loop through the array from beginning to end of populated elements
        
        
            // Initialize a local rat object variable for each iteration
            
 
            // check to see if there is a match
            
            
                // there is a match
                
                // Initialize a local result object variable for this iteration
                
            
                // create a temporary time object that contains the 
                // time it took the rat to complete the maze (diff time)
                
                
                // get the diff time total seconds
                
                
                // increment the count and
                // add the seconds to the total seconds
                
                
            
        
        
        if (count == 0)
        {
            // no rats were found that matched the category
            return 0;
        }
        else
        {
            // compute the average seconds to complete the maze
            return timeInSeconds / count;
        }
    }           
     
    /**
     * determine if the category matches condition.
     * 
     * @param  inCategory Numeric value representing a result category.
     * @param  inRat Rat object with associated attributes.
     * @return boolean Boolean result of category check.
     *  
     */
    public boolean isCategoryMatch(int inCategory, Rat inRat)
    {
        // set the boolean value to false, if a match is 
        // found it will be set to true
        boolean isValid = false;
        
        if (inCategory == MALE)
        {
            // check both upper and lower case
            if (inRat.getGender() == 'M' || inRat.getGender() == 'm')
            {
                isValid = true;
            }
        }
        else if (inCategory == FEMALE)
        {
            // your code here
        }
        else if (inCategory == VACCINATED)
        {
            // your code here
        }
        else if (inCategory == NOT_VACCINATED)
        {
            // your code here
        }

        else if (inCategory == ALL)
        {
            isValid = true;
        }
        
        // error case
        else
        {
            isValid = false;
        }
        
        // will return false if no match, true if match
        return isValid;
    } 
        
    /**
     * get a formatted string with information about a competition.
     * 
     * @return String String with information about a competition.
     */
    public String toString()
    {
        
        // your code here, place the "X" and -9 with appropriate
        // references to instance variables or calls to methods
        String output = "Competition Description: " + "X"
            + "\nCompetition Count: " + -9 + "\n"; 
        output += "Competition Results:" + "\n";
        // loop through the array from beginning to end of populated elements
        
         
            // get toString() for each result
            
        
        return output;
    }
    
}    

