
/**
 * Driver to demonstrate the Competition class.
 * 
 * @author Tina Comston
 * @version Winter 2018
 */
public class CompetitionDriver
{
    
    /**
     * Creates MazeResult objects, calls methods, displays information.
     * 
     */
    public static void main(String[] args)
    {
        Competition set1 = new Competition("Maze Competition #1");
        
        // male, not vaccinated
        Rat r1 = new Rat("145FF34E0", 'M', false);
        MazeResult mr1 = new MazeResult(r1);
        mr1.setStartTime(0, 0, 0);
        mr1.setEndTime(0, 7, 30);
        set1.addMazeResult(mr1);
        
        // female, vaccinated
        Rat r2 = new Rat("284EE32C9", 'F', true);
        MazeResult mr2 = new MazeResult(r2);
        mr2.setStartTime(0, 0, 0);
        mr2.setEndTime(0, 5, 1);        
        set1.addMazeResult(mr2); 
        
        //  female, vaccinated
        Rat r3 = new Rat("377777777", 'F', true);
        MazeResult mr3 = new MazeResult(r3);
        mr3.setStartTime(0, 0, 0);
        mr3.setEndTime(1, 1, 45);        
        set1.addMazeResult(mr3);
        
        // male, vaccinated
        Rat r4 = new Rat("4E3EE33EE", 'M', true);
        MazeResult mr4 = new MazeResult(r4);
        mr4.setStartTime(0, 0, 0);
        mr4.setEndTime(0, 1, 29);        
        set1.addMazeResult(mr4);
        
        //  male, not vaccinated
        Rat r5 = new Rat("55F66FF90", 'M', false);
        MazeResult mr5 = new MazeResult(r5);
        mr5.setStartTime(0, 0, 0);
        mr5.setEndTime(0, 57, 30);        
        set1.addMazeResult(mr5);
        
        //  female, vaccinated
        Rat r6 = new Rat("675F9EE2A", 'F', true);
        MazeResult mr6 = new MazeResult(r6);
        mr6.setStartTime(0, 0, 0);
        mr6.setEndTime(1, 20, 45);        
        set1.addMazeResult(mr6);
        
        // female, not vaccinated
        Rat r7 = new Rat("787878787", 'F', false);
        MazeResult mr7 = new MazeResult(r7);
        mr7.setStartTime(0, 0, 0);
        mr7.setEndTime(1, 0, 5);        
        set1.addMazeResult(mr7);
        
        // display entire competition
        System.out.println(set1);
        // display select data
        System.out.println("Get RFID of rat in 4th position in array:");
        MazeResult mazeResultObj = set1.getMazeResult(3);
        if (mazeResultObj != null)
        {
            Rat ratObj = mazeResultObj.getRat();
            System.out.println(ratObj.getRFID());
            System.out.println("\nGet count of FEMALE rats:");
            System.out.println(set1.getRatCount(Competition.FEMALE));
            System.out.println("\nGet avg time in sec for VACCINATED rats:");
            double temp = set1.getRatAveTime(Competition.VACCINATED);
            System.out.println(temp);
        }

    }
}
