import static org.junit.Assert.*;
import org.junit.After;
import org.junit.Before;
import org.junit.Test;

/**
 * The test class CompetitionTest.
 *
 * @author  Tina Comston
 * @version Winter 2018
 */
public class CompetitionTest 
{

    private Competition results1;

    /**
     * Sets up the test fixture.
     *
     * Called before every test case method.
     */
    @Before
    public void setUp() 
    {
        results1 = new Competition("Maze Competition #1");
        
       // male, not vaccinated
        Rat r1 = new Rat("145FF34E0", 'M', false);
        MazeResult mr1 = new MazeResult(r1);
        mr1.setStartTime(0, 0, 0);
        mr1.setEndTime(0, 7, 30);
        results1.addMazeResult(mr1);
        
        // female, vaccinated
        Rat r2 = new Rat("284EE32C9", 'F', true);
        MazeResult mr2 = new MazeResult(r2);
        mr2.setStartTime(0, 0, 0);
        mr2.setEndTime(0, 5, 1);        
        results1.addMazeResult(mr2); 
        
        //  female, vaccinated
        Rat r3 = new Rat("377777777", 'f', true);
        MazeResult mr3 = new MazeResult(r3);
        mr3.setStartTime(0, 0, 0);
        mr3.setEndTime(1, 1, 45);        
        results1.addMazeResult(mr3);
        
        // male, vaccinated
        Rat r4 = new Rat("4E3EE33EE", 'M', true);
        MazeResult mr4 = new MazeResult(r4);
        mr4.setStartTime(0, 0, 0);
        mr4.setEndTime(0, 1, 29);        
        results1.addMazeResult(mr4);
        
        //  male, not vaccinated
        Rat r5 = new Rat("55F66FF90", 'm', false);
        MazeResult mr5 = new MazeResult(r5);
        mr5.setStartTime(0, 0, 0);
        mr5.setEndTime(0, 57, 30);        
        results1.addMazeResult(mr5);
        
        //  female, vaccinated
        Rat r6 = new Rat("675F9EE2A", 'F', true);
        MazeResult mr6 = new MazeResult(r6);
        mr6.setStartTime(0, 0, 0);
        mr6.setEndTime(1, 20, 45);        
        results1.addMazeResult(mr6);
        
        // female, not vaccinated
        Rat r7 = new Rat("787878787", 'F', false);
        MazeResult mr7 = new MazeResult(r7);
        mr7.setStartTime(0, 0, 0);
        mr7.setEndTime(1, 0, 5);        
        results1.addMazeResult(mr7);
    }
    
    /**
     * Tears down the test fixture.
     *
     * Called after every test case method.
     */
    @After
    public void tearDown()
    {
        // anything needed after test cases complete
    }
    /**
     * Test domain class constructor.
     */
    @Test
    public void testCreateObject()
    {
        // replace this statement
        assertTrue(false);
        
        // declare local Competition object
        // asset reference is not null, description is as expected, 
        // count is as expected

    }
    
    /**
     * Test set Competition description.
     */
    @Test
    public void testSetDescription()
    {
        // replace this statement
        // use results1 instance variable
        assertTrue(false);
    } 
    
    /**
     * Test get count.
     */
    @Test
    public void testGetCount()
    {
        // replace this statement
        // use results1 instance variable
        assertTrue(false);
    }
    
    /**
     * Test add maze result.
     */
    @Test
    public void testAddMazeResult()
    {
        Rat ratObj = new Rat();
        MazeResult mazeResultObj;

        // add 100 objects
        for (int i = 0; i < 100; i++)
        {
            mazeResultObj = new MazeResult(ratObj);
            results1.addMazeResult(mazeResultObj);
            assertNotNull(results1.getMazeResult(results1.getCount() - 1)); 
        }
        
        // add 1 more to make sure getCount doesn't change
        // which means the object wasn't added
        mazeResultObj = new MazeResult(ratObj);
        results1.addMazeResult(mazeResultObj);
        assertEquals(100, results1.getCount()); 

        
    }
    
    /**
     * Test get maze result by postion.
     */
    @Test
    public void testGetMazeResultByPos()
    {
        // test return of specific position
        MazeResult mazeResultObj =
            results1.getMazeResult(results1.getCount() - 1);
        Rat ratObj = mazeResultObj.getRat();
        assertEquals("787878787", ratObj.getRFID());
        assertEquals('F', ratObj.getGender());
        assertFalse(ratObj.getIsVaccinated());
            
        // test default return
        mazeResultObj =
            results1.getMazeResult(results1.getCount());
        assertNull(mazeResultObj);
            
    }
    
    /**
     * Test get maze result by rat chip ID name.
     */
    @Test
    public void testGetMazeResultByRFID()
    {
        // replace this statement
        assertTrue(false);
        
        // see test method above; similar logic except
        // you will pass in a chip ID rather than an index
    } 
    
    /**
     * Test get maze count by category:
     *     MALE, FEMALE, VACCINATED, NOT_VACCINATED, ALL.
     */
    @Test
    public void testGetMazeCount()
    {
        assertEquals(3, results1.getRatCount(Competition.MALE));
        // your code here for the four remaining categories
        assertTrue(false);
    }
    
    /**
     * Test get maze average time by category:
     *     MALE, FEMALE, VACCINATED, NOT_VACCINATED, ALL.
     */
    @Test
    public void testGetMazeAve()
    {
        assertEquals(1329.66, 
            results1.getRatAveTime(Competition.MALE), .01);
        // your code here for the four remaining categories
        assertTrue(false);

    }

    /**
     * Test is category valid helper method by category:
     *     MALE, FEMALE, VACCINATED, NOT_VACCINATED, ALL.
     */
    @Test
    public void testIsCategoryMatch()
    {
        MazeResult mazeResultObj =
            results1.getMazeResult("4E3EE33EE");            
        Rat ratObj = mazeResultObj.getRat();
        assertTrue(results1.isCategoryMatch(Competition.MALE, ratObj));
        // your code here for the four remaining categories
        // use assertTrue or assertFalse as appropriate
        assertTrue(false);
    }
    
    /**
     * Test the toString method.
     */
    @Test
    public void testToString()
    {
        String output = results1.toString();
        // test description is in output
        
        // your code here, OK to just test for description and count
        assertTrue(false);
    }

}
